include get.e
include misc.e
include machine.e

-- hexadecimal
global procedure printh(integer fn, atom n, integer plcs)
atom m
	m = power(2,plcs*4)-1
	if m > #FFFFFFFF then m = #FFFFFFFF end if
	puts(fn,sprintf("%0" & sprint(plcs) & "x",and_bits(m,n))) 
end procedure

-- octal
global procedure printo(integer fn, atom n, integer plcs)
atom m
	m = power(2,plcs*3)-1
	if m > #FFFFFFFF then m = #FFFFFFFF end if
	puts(fn,sprintf("%0" & sprint(plcs) & "o",and_bits(m,n))) 
end procedure

-- binary
function bs(atom n, integer plcs)
 -- plcs<=0 convert all no pad
 -- plcs>0 convert plcs bits pad with '0' to length=plcs
 sequence s
	s=""
	while n>0 do
		if remainder(n,2) then
			s=prepend(s,'1')
		else
			s=prepend(s,'0')
		end if
		n=floor(n/2)
		if length(s) = plcs then
			exit
		end if
	end while
	if length(s) < plcs then
		s = repeat('0',plcs-length(s)) & s
	end if
	return s
end function

global procedure printb(integer fn, atom n, integer plcs)
	puts(fn,bs(n,plcs)) 
end procedure

global procedure print_bytes(integer fn, atom n, integer b)
 -- b = 1 print binary format
 -- b = 0 print hex format
 sequence bytes
	bytes=reverse(int_to_bytes(n))
	if b then
		for i = 1 to 4 do
			printb(fn,bytes[i],8) puts(fn," ")
		end for
	else
		for i = 1 to 4 do
			printh(fn,bytes[i],2) puts(fn," ")
		end for
	end if
end procedure

