without warning
include misc.e
include get.e
include file.e

constant cmdln = command_line()

sequence infile,outfile  infile = "" outfile = ""
sequence bytes,bytes_to_drop,comment   bytes = {} bytes_to_drop = {} comment = {"--","--","--"}
sequence buf  buf = {}
object tmp,val  tmp = {} val = {}
integer comments,empty,trailing  comments = 0 empty = 0 trailing = 0
integer fn  fn = 1
integer p,k,first,last
integer report,nbytes,ncomments,nempty,ntrailing  report = 0 nbytes = 0 ncomments = 0 nempty = 0 ntrailing = 0

if length(cmdln) < 3 then
	puts(1,"No parameters on command line\n\nPress Enter")
	k = wait_key()
	abort(1)
end if	

for i=3 to length(cmdln) do
	if match("in:",cmdln[i]) then
		infile = cmdln[i][4..$]
		while 1 do
			p = find('"',infile)
			if p then
				infile = infile[1..p-1] & infile[p+1..$]
			else
				exit
			end if
		end while
	elsif match("out:",cmdln[i]) then
		outfile = cmdln[i][5..$]
		while 1 do
			p = find('"',outfile)
			if p then
				outfile = outfile[1..p-1] & outfile[p+1..$]
			else
				exit
			end if
		end while
	elsif match("bytes:",cmdln[i]) then
		tmp = cmdln[i][7..$]
		while length(tmp) do
			p = find(',',tmp)
			if p then
				bytes = tmp[1..p-1]
				tmp = tmp[p+1..$]
			else
				bytes = tmp
				tmp = {}
			end if
			p = find('-',bytes)
			if p then
				val = value(bytes[1..p-1])
				first = val[2]
				val = value(bytes[p+1..$])
				last = val[2]
				for j=first to last do
					bytes_to_drop &= j
				end for
			else
				val = value(bytes)
				bytes_to_drop &= val[2]
			end if
		end while
	elsif match("comments:",cmdln[i]) then
		val = value(cmdln[i][10..$])
		comments = floor(val[2])
	elsif match("comment:",cmdln[i]) then
		tmp = cmdln[i][9..$]
		while length(tmp) do
			p = find(',',tmp)
			if p then
				bytes = tmp[1..p-1]
				tmp = tmp[p+1..$]
			else
				bytes = tmp
				tmp = {}
			end if
			comment = append(comment,bytes)
		end while
	elsif match("empty:",cmdln[i]) then
		val = value(cmdln[i][7..$])
		empty = floor(val[2])
	elsif match("trailing:",cmdln[i]) then
		val = value(cmdln[i][10..$])
		trailing = floor(val[2])
	elsif equal("?",cmdln[i]) then
		report = 1
	end if
end for

if not length(infile) then
	puts(1,"No input file name\n\nPress Enter")
	k = wait_key()
	abort(1)
else
	fn = open(infile,"r")
	if fn = -1 then
		puts(1,"Can't open input \"" & infile & "\"\n\nPress Enter")
		k = wait_key()
		abort(1)
	else
		while 1 do
			tmp = gets(fn)
			if atom(tmp) then
				exit
			end if
			if tmp[$] = '\n' then
				tmp = tmp[1..$-1]
			end if
			buf = append(buf,tmp)
		end while
		close(fn)
	end if
end if

function is_whitespace(sequence s)
	for i=1 to length(s) do
		if s[i] != ' ' and s[i] != '\t' then
			return 0
		end if
	end for
	return 1
end function

function is_comment(sequence s)
	for i=1 to length(comment) do
		p = match(comment[i],s)
		if p then
			return p
		end if
	end for
	return 0
end function

integer ne  ne = 0
function clean(object s)
	integer p
	if comments then
		p = is_comment(s)
		if p then
			if p = 1 or is_whitespace(s[1..p-1]) then
				if ne >= empty then
					ne += 1 ncomments += 1 nempty += 1
					return -1 -- mark for removal
				else
					s = {} ncomments += 1
				end if
			else
				s = s[1..p-1]
			end if
		end if
	end if
	if empty then
		if not length(s) or is_whitespace(s) then
			ne += 1
			if ne >= empty then
				nempty += 1
				return -1
			else
				s = {}
			end if
		else
			ne = 0
		end if
	end if
	if trailing then
		p = length(s)
		while p do
			if s[p] != ' ' and s[p] != '\t' then
				exit
			end if
			p -= 1
		end while
		ntrailing += length(s) - p
		s = s[1..p]
	end if
	if length(bytes_to_drop) then
		for i=1 to length(s) do
			if find(s[i],bytes_to_drop) then
				s = s[1..i-1] & s[i+1..$]
				nbytes += 1
			end if
		end for
	end if
	return s
end function
	
for i=1 to length(buf) do
	buf[i] = clean(buf[i])
end for

fn = 1
if length(outfile) then
	fn = open(outfile,"w")
	if fn = -1 then
		puts(1,"Can't open output \"" & outfile & "\"\n\nPress Enter")
		k = wait_key()
		abort(1)
	end if
end if

for i=1 to length(buf) do
	if not atom(buf[i]) then
		puts(fn,buf[i] & '\n')
		flush(fn)
	end if
end for
if fn > 3 then
	close(fn)
end if

-- Command line arguments:
-- The default is to do no processing, calling clean.e "my_file.e" will just print the file to standard out.
-- in:		Input file name, if the name has spaces in it use "in:name with spaces.e"
-- out:		Optional output file name, can be any valid file name or empty. If no file name is supplied output is to standard out.
-- bytes:	Delete bytes found in the list of bytes. This is accumulative bytes:0-3 is the same as bytes:0 bytes:1 bytes:2 bytes:3,
--		bytes:0-8,10-31 will delete all control codes except tab, linefeed and return are stripped when the file is read.
-- comments:	A value of 1 will delete comments.
-- comment:	This will override the default value of {"--","--","--"} for comment start, comment middle and comment end.
--		A value of comment:/*,*,*/ would work for Scite c++ box comments.
-- empty:	Delete empty lines,  a value of 1 will delete all empty lines, 2 will delete lines only if two or more consecutive lines are empty etc.
-- ?		Prints report to StdOut when done.
--exw.exe clean.e "in:bits.e" "out:bits.e" bytes:0-8,10-31 trailing:1 comments:1 empty:1

if report then
	puts(1,comment[1] & "Command Line:" & '\n' & comment[1])
	for i=1 to length(cmdln) do
		puts(1,cmdln[i] & ' ')
	end for
	puts(1,"\n\n")
	puts(1,comment[1] & "Number of bytes matched and deleted = " & sprint(nbytes) & '\n')
	puts(1,comment[1] & "Number of comments deleted = " & sprint(ncomments) & '\n')
	puts(1,comment[1] & "Number of empty lines deleted = " & sprint(nempty) & '\n')
	puts(1,comment[1] & "Number of trailing blanks deleted = " & sprint(ntrailing) & '\n')
	k=wait_key()
end if


