include machine.e
include dll.e
include get.e

constant
ARGS = allocate(512),
NARGS = allocate(4),
FUNC = allocate(4),
RET = allocate(4)

-- push ecx
-- mov ecx,[NARGS]
-- jecxz @1 ; skip if zero args
-- mov eax,OFFSET ARGS
-- @@:
-- push [eax-4+ecx*4] ; push args right to left
-- loop @B
-- @1:
-- call [FUNC]
-- pop ecx
-- mov [RET],eax
-- ret

constant code = allocate_string(
{#51} &
{#8B,#0D} & int_to_bytes(NARGS) &
{#E3,#0B} &
{#B8} & int_to_bytes(ARGS) &
{#FF,#74,#88,#FC} &
{#E2,#FA} &
{#FF,#15} & int_to_bytes(FUNC) &
{#59} &
{#A3} & int_to_bytes(RET) &
{#C3}
)

global function std_call(atom pointer, sequence params)
	poke4(ARGS,params) poke4(NARGS,length(params)) poke4(FUNC,pointer)
	call(code)
	return peek4u(RET)
end function

global procedure std_call_void(atom pointer, sequence params)
	poke4(ARGS,params) poke4(NARGS,length(params)) poke4(FUNC,pointer)
	call(code)
end procedure

----------------------------------------------------------------------------------
constant
k32 = open_dll("kernel32.dll"),
GPA = define_c_func(k32,"GetProcAddress",{C_ULONG,C_ULONG},C_INT)
global function get_proc_address(atom lib, sequence procName) -- lib address from open_dll()
atom name,proc
	name = allocate_string(procName)
	proc = c_func(GPA,{lib,name})
	free(name)
	return proc
end function

--constant
--u32=open_dll("user32.dll"),
--SM_CXSCREEN=0,SM_CYSCREEN=1,
--GetSystemMetrics=get_proc_address(u32,"GetSystemMetrics")
--? {std_call(GetSystemMetrics,{SM_CXSCREEN}),std_call(GetSystemMetrics,{SM_CYSCREEN})}





